import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;
/**
 *   :  
 * @author  , '  
 * @version 16/4/2007
 */
public class MergeLists
{
	public static List<Double> merge (List<Double> lst1, List<Double> lst2)
	{
		if (lst1 == null)
			return lst2;
		if (lst2 == null)
			return lst1;
		Node<Double> p1 = lst1.getFirst();
		Node<Double> p2 = lst2.getFirst();
		if (p1 == null)
			return lst2;
		if (p2 == null)
			return lst1;
		
		List<Double> mergeList = new List<Double>();
		Node<Double> p = null;
		while (p1 != null && p2 != null)
		{
			if (p1.getInfo() < p2.getInfo())
			{
				p = mergeList.insert(p, p1.getInfo());
				p1 = p1.getNext();
			}
			else
			{
				p = mergeList.insert(p, p2.getInfo());
				if (p1.getInfo().equals(p2.getInfo()))
					p1 = p1.getNext();
				p2 = p2.getNext();
			}
		}

		//when we reach here, we finished one list
		
		while (p1 != null)
		{
			p = mergeList.insert(p, p1.getInfo());
			p1 = p1.getNext();
		}
		while (p2 != null)
		{
			p = mergeList.insert(p, p2.getInfo());
			p2 = p2.getNext();
		}
		return mergeList;
	}
}
